diff --git a/src/base/async/int.c b/src/base/async/int.c
index 275b5490f9..0e8745fb65 100644
--- a/src/base/async/int.c
+++ b/src/base/async/int.c
@@ -1933,9 +1933,13 @@ static void do_int_from_thr(void *arg)
     run_caller_func(i, NO_REVECT);
     if (debug_level('#') > 2)
 	debug_int("RET", i);
+/* for now dosdebug uses int_revect feature, so this should be disabled
+ * or it will display the same entry twice */
+#if 0
 #ifdef USE_MHPDBG
     mhp_debug(DBG_INTx + (i << 8), 0, 0);
 #endif
+#endif
 }
 
 /*
diff --git a/src/emu-i386/do_vm86.c b/src/emu-i386/do_vm86.c
index a1d182cc5b..7382329637 100644
--- a/src/emu-i386/do_vm86.c
+++ b/src/emu-i386/do_vm86.c
@@ -445,7 +445,7 @@ static int do_vm86(struct vm86_struct *x)
 
 static void _do_vm86(void)
 {
-    int retval, vtype;
+    int retval, vtype, dret;
 
     if (isset_IF() && isset_VIP()) {
 	error("both IF and VIP set\n");
@@ -496,10 +496,11 @@ static void _do_vm86(void)
 	I_printf("Return from vm86() for STI\n");
 	break;
     case VM86_INTx:
-	do_int(VM86_ARG(retval));
 #ifdef USE_MHPDBG
-	mhp_debug(DBG_INTx + (VM86_ARG(retval) << 8), 0, 0);
+	dret = mhp_debug(DBG_INTx + (VM86_ARG(retval) << 8), 1, 0);
 #endif
+	if (!dret)
+	    do_int(VM86_ARG(retval));
 	break;
 #ifdef USE_MHPDBG
     case VM86_TRAP:
diff --git a/src/include/mhpdbg.h b/src/include/mhpdbg.h
index 9438db2d9c..92f900a890 100644
--- a/src/include/mhpdbg.h
+++ b/src/include/mhpdbg.h
@@ -128,6 +128,7 @@ struct mhpdbgc
    int bpload;
    int bpload_bp;
    int int21_count;
+   int int_handled;
    struct mhpdbg_4bpar *bpload_par;
    char bpload_cmd[128];
    char bpload_cmdline[132];
diff --git a/src/tools/debugger/mhpdbg.c b/src/tools/debugger/mhpdbg.c
index 4f695bf881..fd47d91456 100644
--- a/src/tools/debugger/mhpdbg.c
+++ b/src/tools/debugger/mhpdbg.c
@@ -435,7 +435,14 @@ unsigned int mhp_debug(enum dosdebug_event code, unsigned int parm1, unsigned in
 	    else {
 	      if ((DBG_ARG(mhpdbgc.currcode) != 0x21) || !mhpdbgc.bpload ) {
 	        mhpdbgc.stopped = 1;
+	        if (parm1)
+	          LWORD(eip) -= 2;
+	        mhpdbgc.int_handled = 0;
 	        mhp_poll();
+	        if (mhpdbgc.int_handled)
+	          rtncd = 1;
+	        else if (parm1)
+	          LWORD(eip) += 2;
 	      }
 	    }
 	  }
diff --git a/src/tools/debugger/mhpdbgc.c b/src/tools/debugger/mhpdbgc.c
index 53b5173390..b8cfab037e 100644
--- a/src/tools/debugger/mhpdbgc.c
+++ b/src/tools/debugger/mhpdbgc.c
@@ -585,6 +585,7 @@ static void mhp_trace(int argc, char * argv[])
 	    do_int(csp[1]);
 	    set_TF();
 	    mhpdbgc.stopped = 1;
+	    mhpdbgc.int_handled = 1;
 	    mhp_cmd("r0");
 	}
       }
